/*
Programm: Aufg.01
Zweck:    Programm zur Bearbeitung von Polygonen 
Aufgabe:  Entspricht der Aufgabe 1 der Uebungsaufgaben zur Vorlesung 
          "Programmierung 3" bei Prof. Henrich im WS 2002/2003.
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2002-10-08
*/

#include <iostream>
using namespace std;

class Vektor {
  public:
    Vektor() : x(0),y(0) { };
    void lese(istream &s);
    int x,y;
};

class Punkt {
  public:
    Punkt() : x(0),y(0) { }; 
    void lese(istream &s);
    void schreibe(ostream &s);
    void verschiebe(Vektor vec);
  private:  
    int x,y;
};

class PunktListenElement {
  public:
    PunktListenElement();
    ~PunktListenElement();
    PunktListenElement(Punkt);
    Punkt dieser;
    PunktListenElement* naechster;
};

class Polygon {
  public:
    Polygon();
    void leseFarbe(istream &s);
    void lesePunkte(istream &s);
    void schreibe(ostream &s);
    void verschiebe(Vektor vec);
  private:
    int farbe;
    PunktListenElement erstesElement;
};


/*------implementations------*/

Polygon::Polygon() : farbe(0) {}

void Polygon::leseFarbe(istream &s) {
  s >> farbe;
}

void Polygon::lesePunkte(istream &s) {
  char c;
  s >> c;
  if (c != '(' ) {
    cout << "FEHLER: ( erwartet !" << endl;
    return;
  }
  erstesElement.dieser.lese(s);
  PunktListenElement* vorigesElement = &erstesElement;
  s >> c;
  while (c == ',') {
    Punkt aktuellerPunkt = *(new Punkt());
    aktuellerPunkt.lese(s);
    vorigesElement->naechster = new PunktListenElement(aktuellerPunkt);
    vorigesElement = vorigesElement->naechster;
    s >> c;
  }
  vorigesElement->naechster = 0;
  if (c !=  ')' ) {
    cout << "FEHLER: ) erwartet !" << endl;
    return;
  } 
}

void Polygon::schreibe(ostream &s) {
  s << "Farbkennzeichen: " << farbe << endl;
  s << "Eckpunkte: (";
  erstesElement.dieser.schreibe(s);
  PunktListenElement* listenElement = erstesElement.naechster;
  while (listenElement) {
    s << ",";
    listenElement->dieser.schreibe(s);
    listenElement = listenElement->naechster;
  }
  s << ")" << endl;
}

void Polygon::verschiebe(Vektor vec) {
  PunktListenElement* listenElementPtr = &erstesElement;
  while(listenElementPtr) {
    listenElementPtr->dieser.verschiebe(vec);
    listenElementPtr = listenElementPtr->naechster;
  } 
}

void Punkt::lese(istream &s) {
  char c;
  s >> c;
  if (c != '(' ) {
    cout << "FEHLER: ( erwartet !\n";
    return;
  }
  s>>x;
  s>>c;
  if (c != ',' ) {
    cout << "FEHLER: , erwartet !\n";
    return;
  }
  s>>y;
  s>>c;
  if (c !=  ')' ) {
    cout << "FEHLER: ) erwartet !\n";
    return;
  } 
}

void Punkt::schreibe(ostream &s) {
  s << "(" << x << "," << y << ")";
}

void Punkt::verschiebe(Vektor vec) {
  x += vec.x;
  y += vec.y;
}

PunktListenElement::PunktListenElement() {
  naechster=0;
}

PunktListenElement::~PunktListenElement() {
  delete naechster; //rekursiver Destruktor; beachte: delete NULL hat keinen Effekt
                    //und bildet das Rekursionsende
}

PunktListenElement::PunktListenElement(Punkt pkt) {
  dieser = pkt;
  naechster=0; 
}

void Vektor::lese(istream &s) {
  char c;
  s >> c;
  if (c != '(' ) {
    cout << "FEHLER: ( erwartet !\n";
    return;
  }
  s>>x;
  s>>c;
  if (c != ',' ) {
    cout << "FEHLER: , erwartet !\n";
    return;
  }
  s>>y;
  s>>c;
  if (c !=  ')' ) {
    cout << "FEHLER: ) erwartet !\n";
    return;
  } 
}

int main() {
  Polygon aPolygon;
  Vektor  moveVektor;
  
  cout << "Farbkennzeichen des Polygons?: ";
  aPolygon.leseFarbe(cin);
  
  cout << "Punkte eingeben in der Form ((x1,y1),(x2,y2),(x3,y3)): ";
  aPolygon.lesePunkte(cin);

  cout << endl << "Ihr eingegebenes Polygon: " << endl;
  aPolygon.schreibe(cout);
  
  cout << endl << "Verschiebe Polygon um Vektor in der Form (x,y): ";
  moveVektor.lese(cin);

  aPolygon.verschiebe(moveVektor);  

  cout << endl << "Ihr verschobenes Polygon: " << endl;
  aPolygon.schreibe(cout);
}
