/*
Programm: Aufg.04.1
Zweck:    Programm zur Modellierung von Fahrzeug und Rennauto 
Aufgabe:  Entspricht der Aufgabe 1 Blatt 4 der Uebungsaufgaben zur Vorlesung 
          "Programmierung 3" bei Prof. Henrich im WS 2002/2003.
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2002-10-29
*/

#include <iostream>
using namespace std;

class Fahrzeug {
  private:
    int v;
    int v_max;
  public:
    static const int V=0;
    static const int V_MAX=1;
    Fahrzeug();
    Fahrzeug(int v_max_value);
    void show (const int element);
    int& value(const int element);
    void accelerate();
    void slowdown();
};

class Rennauto: public Fahrzeug {
  public: 
    Rennauto();
    Rennauto(int v_max_value);
    void accelerate();
    void slowdown();
};

Fahrzeug::Fahrzeug():v(0),v_max(100) {}

Fahrzeug::Fahrzeug(int v_max_value) { v=0; v_max=v_max_value;}

void Fahrzeug::show(const int element) {
  switch(element) {
    case V:     cout << v;     break;
    case V_MAX: cout << v_max; break;
    default:                   break;
  };
}

//returns v if parameter is not recognized as connected with a data element
int& Fahrzeug::value(const int element) {
  switch(element) {
    case V:     return v;     break;
    case V_MAX: return v_max; break;
    default:    return v;     break;
  };
} 

void Fahrzeug::accelerate() {
  value(V) += 20;
  if (value(V) > value(V_MAX)) 
    value(V) = value(V_MAX);
}

void Fahrzeug::slowdown() {
  value(V) -= 15;
  if (value(V) < 0)
    value(V) = 0;
}

Rennauto::Rennauto() {
}

Rennauto::Rennauto(int v_max_value) {
  value(V_MAX)=v_max_value;
}

void Rennauto::accelerate() {
  value(V) += 40;
  if (value(V) > value(V_MAX))
    value(V) = value(V_MAX);
}

void Rennauto::slowdown() {
  value(V) -= 30;
  if (value(V) < 0)
    value(V) = 0;
}

int main() {
  int v_max;
  
  cout << "Maximalgeschwindigkeit des Fahrzeugs: ";
  cin >> v_max;
  Fahrzeug fahrzeug(v_max);
  
  cout << "Maximalgeschwindigkeit des Rennautos: ";
  cin >> v_max;
  Rennauto rennauto(v_max);

  while(true) {
    cout << endl << "Geschwindigkeit des Fahrzeugs: ";
    fahrzeug.show(fahrzeug.V);
    fahrzeug.accelerate();
    
    cout << endl << "Geschwindigkeit des Rennautos: ";
    rennauto.show(fahrzeug.V);
    rennauto.accelerate();
  }
}
