/*
Programm: Aufg.07.1
Zweck:    Entwurfsmuster Klassenadapter
Aufgabe:  Entspricht der Aufgabe 1 Blatt 07 der Uebungsaufgaben zur Vorlesung
          "Programmierung 3" bei Prof. Henrich im WS 2002/2003.
Autor:    Mattias Ansorg <matthias@ansorgs.de>
Lizenz:   public domain
Datum:    2003-01-22
*/

#include <iostream>
using namespace std;

class Komplex{
  protected:
    int re;
    int im;
  public:
    Komplex(int r=3,int i=7);
    void ausgabe();
};

class Zahl {
  public:
    virtual void inkr()=0;
    virtual void show()=0;
};

class Integer : public Zahl {
  public:
    Integer();
    Integer(int wert);
    virtual void inkr();
    virtual void show();
  private:
    int theInt;
};

class Modulo_5 : public Zahl {
  public:
    Modulo_5();
    Modulo_5(int wert);
    virtual void inkr();
    virtual void show();
  private:
    int theMod_5;
};

class KomplexAdapter : public Zahl, private Komplex {
  public:
    KomplexAdapter();
    KomplexAdapter(int reWert, int imWert);
    virtual void inkr();
    virtual void show();
};

//--------------------- Implementations -----------------------

Komplex::Komplex(int r, int i) : re(r),im(i) {
}

void Komplex::ausgabe() {
  cout << "Re: " << re
       <<" Im: " << im <<endl;
}

Integer::Integer() : theInt(0) {
}

Integer::Integer(int wert) : theInt(wert) {
}

void Integer::inkr() {
  ++theInt;
}

void Integer::show() {
  cout << theInt << endl;
}

Modulo_5::Modulo_5() : theMod_5(0) {
}

Modulo_5::Modulo_5(int wert) : theMod_5(wert%5) {
}

void Modulo_5::inkr() {
  ++theMod_5;
  if (theMod_5 == 5)
    theMod_5 = 0;
}

void Modulo_5::show() {
  cout << theMod_5 << endl;
}

KomplexAdapter::KomplexAdapter() : Komplex(0,0) {
}

KomplexAdapter::KomplexAdapter(int reWert, int imWert) : Komplex(reWert, imWert) {
}

void KomplexAdapter::inkr() {
  ++re;
  ++im;
}

void KomplexAdapter::show() {
  ausgabe();
}

int main() {
  char art;
  int wert, reWert, imWert;
  int i=0;
  const int zahlanzahl = 3;
  Zahl *zahlPtrVec[zahlanzahl];

  //Zahlen anlegen, Benutzer bestimmt Art und Werte
  while (i < zahlanzahl) {
    cout << endl << "Welche Art Zahl anlegen? (I=Integer M=Modulo_5 K=Komplex) ";
    cin >> art;
    switch (art) {
      case 'I':
        cout << "Wert: ";
        cin >> wert;
        zahlPtrVec[i] = new Integer(wert);
        break;
      case 'M':
        cout << "Wert: ";
        cin >> wert;
        zahlPtrVec[i] = new Modulo_5(wert);
        break;
      case 'K':
        cout << "Realteil: ";
        cin >> reWert;
        cout << "Imaginrteil: ";
        cin >> imWert;
        zahlPtrVec[i] = new KomplexAdapter(reWert, imWert);
        break;
      default:
        cout << "Falsche Eingabe!" << endl;
        continue;
    }
    ++i;
  }

  //alle Zahlen inkrementieren und ausgeben
  cout << endl << "Liste aller eingegebenen Zahlen, je um 1 inkrementiert:" << endl;
  for (int i=0; i<zahlanzahl; ++i) {
    zahlPtrVec[i]->inkr();
    zahlPtrVec[i]->show();
  }
}
