/*
Programm: Aufg.08.1
Zweck:    Programm zur Modellierung von Matrix und Vektor, so dass die 
          Multiplikation einer Matrix mit einem Vektor per Operator ausfhrbar ist.
Aufgabe:  Entspricht der Aufgabe 1 Blatt 8 der Uebungsaufgaben zur Vorlesung 
          "Programmierung 3" bei Prof. Henrich im WS 2002/2003.
Autor:    Mattias Ansorg <matthias@ansorgs.de>
Lizenz:   public domain
Datum:    2002-11-26
*/

#include <iostream>
using namespace std;

class Matrix;

class Vektor {
  friend Vektor operator*(Matrix, Vektor);
  private:
    int _data[2];
  public:
    Vektor();
    void show();
};

class Matrix {
  friend Vektor operator*(Matrix,Vektor);
  private:
    int _data[2][2];
  public:
    Matrix();
    void show();
};

Vektor::Vektor() {
  _data[0] = 7;
  _data[1] = 8;
}

void Vektor::show() {
  cout << _data[0] << " " << _data[1];
}

Matrix::Matrix() {
  _data[0][0] = 1;
  _data[0][1] = 2;
  _data[1][0] = 2;
  _data[1][1] = 4;
}

void Matrix::show() {
  cout << endl << _data[0][0] << " " << _data[0][1]
       << endl << _data[1][0] << " " << _data[1][1];
}

Vektor operator*(Matrix matrix, Vektor vektor) {
  Vektor result;
  result._data[0] = 0; //ueberschreibe Standard-Initialisierung
  result._data[1] = 0;
  for (int i=0; i<=1; ++i) { //fuer alle Zeilen der Matrix:
    //multipliziere Zeile matrix[i][] mit vektor, speichere in result[i]
    for (int j=0; j<=1; ++j) //fuer alle Spalten der Matrix:
      result._data[i] += matrix._data[i][j] * vektor._data[j];
  } 
  return result;
}

int main() {
  Matrix m;
  cout << "Matrix: ";
  m.show(); 
  cout << endl;
  
  Vektor v; 
  cout << "Vektor: ";
  v.show();
  cout << endl;
  
  cout << "Produkt: ";
  (m*v).show();
  cout << endl;
}
