/*
Programm: Aufg.10.3
Zweck:    Schreibtischtest eines vorgegebenen Programms und Korrektur
          darin enthaltener Speicherlecks.
Aufgabe:  Entspricht der Aufgabe 3 Blatt 10 der Uebungsaufgaben zur Vorlesung
          "Programmierung 3" bei Prof. Henrich im WS 2002/2003. Diese Lsung
          entspricht im Wesentlichen der von Prof. Henrich ausgeteilten
          Musterlsung.
Autor:    Mattias Ansorg <matthias@ansorgs.de>
Lizenz:   public domain
Datum:    2003-01-22
*/

/*
Die Ausgabe dieses Programms ist, wie jeder leicht feststellen kann:
 i: 5 j: 6 *ip: 7
 i: 55 j: 66 *ip: 77
Der Trick:
-- selbstdefinierter Kopierkonstruktor von C fehlt. Deshalb
wird in der Anweisung C c2=(*cp); nur eine flache Kopie erzeugt und
c2->ip enthlt danach dieselbe Adresse wie cp->ip. Diese Anweisung ist
keine Zuweisung, sondern eine Definition mit Initialisierung! Deshalb wird
der Zuweisungsoperator und nicht der Kopierkonstruktor aufgerufen, denn
C c2=(*cp); ist quivalent mit C c2(*cp);.
-- Destruktor von C fehlt. Deshalb wird bei delete cp; nur ip gelscht, 
nicht jedoch der Integer, auf den ip zeigt. Dieser ist weiterhin von c2 
referenziert und wird auch mit ausgegeben.
*/

#include <iostream>
using namespace std;

class A{
  public:
    int i;
    A():i(5){}
};


class B{
  public:
    int j;
    B():j(6){}
};

class C : public B{
  public:
    int* ip;
    A a;
    C(){ip=new int(7);}
    void show(){cout<<" i: "<<a.i<<" j: "<<j<<" *ip: "<<*ip<<endl;}
};

int main(){
  C* cp = new C;
  (*cp).show();
  (*cp).a.i=55;
  (*cp).j=66;
  *(*cp).ip=77;
  C c2=(*cp);
  delete cp;
  B* bp = new C;
  delete bp;
  c2.show();
}
