/*
Programm: Aufg.11.1
Zweck:    Programm zum Ueben der Verwendung eines Klassen-Templates
Aufgabe:  Entspricht der Aufgabe 1 Blatt 11 der Uebungsaufgaben zur Vorlesung
          "Programmierung 3" bei Prof. Henrich im WS 2002/2003.
Autor:    Mattias Ansorg <matthias@ansorgs.de>
Lizenz:   public domain
Datum:    2002-12-03
*/

/*
Aufgabenstellung:
Gegeben sei die Definition folgender Klasse:

class compl{int re,im;
 public: compl(int r=0,int i=0):re(r),im(i){}
.....
};

Erstellen Sie eine Schablonenklasse, die einen Vektor der Dimension 2
eines variablen Datentyps enthlt. Erstellen Sie in dieser Klasse einen
Operator + der eine Instanz zurckgibt mit dem Summenvektor als Summe
der Komponenten der einzelnen Instanzvektoren.
Bsp.: (3,5) + (4,7) = (7,12) // Addition fr int Vektoren
 (2+3i,5+6i) + (3+4i,6+7i) = (5+7i,11+13i) // Addition fr compl Vektoren

Erweitern Sie gegebenenfalls die Definition der Klasse compl.

Die Vektorein- und ausgabe soll in der Form cin>> v; bzw cout<<v;
fr eine Instanziierung mit compl oder int mglich sein.

Testen Sie in main() den Operators+ fr den Datentyp int und compl unter
Verwendung der Ausgabefunktion.

Speichern Sie die Anzahl der angelegten Instanzen fr die
Instanziierung mit compl bzw. mit int und geben Sie diese aus.
(Kopien sollen nicht beachtet werden)
*/

#include <iostream.h>
#include <curses.h>

//declarations ---------------------------------

class Complex{
public:
  Complex();
  Complex(int r,int i);
  void show();
  Complex operator+(Complex c);
private:
  int re;
  int im;
};

template<class T>
class Vector2dim {
  friend ostream &operator<<(const ostream &out, T vec1);
public:
  Vector2dim(T tt1, T tt2);
  void show();
  Vector2dim<T> operator+(Vector2dim<T> x1);
private:
  T t[2];
};

//definitions -------------------------------------

Complex::Complex() : re(0), im(0) {
}

Complex::Complex(int r, int i) : re(r), im(i) {
}

void Complex::show() {
  cout << re << im << "   ";
}

Complex Complex::operator+(Complex c) {
  return Complex(re+c.re, im+c.im);
}


template<class T>
Vector2dim<T>::Vector2dim(T tt1, T tt2) {
  t[0] = tt1;
  t[1] = tt2;
}

template<class T>
void Vector2dim<T>::show() {
  t[0].show();
  t[1].show();
  cout << endl;
}

template<class T>
Vector2dim<T> Vector2dim<T>::operator+(Vector2dim<T> vec1) {
  return Vector2dim<T>(t[0]+vec1.t[0], t[1]+vec1.t[1]);
}

int main(){
  Vector2dim<int> intVec1(5,6);
  Vector2dim<myint> intVec2(7,8);
  cout << "intVec1: " << intVec1 << endl;
  cout << "intVec2: " << intVec2 << endl;
  cout << "intVec1 + intVec2: " << (intVec1+intVec2) << endl;

  Vector2dim<Complex> compVec1(Complex(1,2),Complex(3,4));
  Vector2dim<Complex> compVec2(Complex(11,22),Complex(33,44));

  compVec1.show();
  compVec2.show();
  cout << "Summe" << endl;
  (xc+xc2).show();
  getch();
}
